import { jsx as i, jsxs as _, Fragment as L } from "react/jsx-runtime";
import d from "clsx";
import * as u from "react";
import T, { useId as P, useRef as j, useEffect as F } from "react";
import { useFloating as G, useClick as D, useDismiss as W, useRole as X, useInteractions as Y, useMergeRefs as q, FloatingPortal as H, FloatingOverlay as J, FloatingFocusManager as K } from "@floating-ui/react";
/*!
  @versini/ui-panel v1.2.3
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PANEL__ || (window.__VERSINI_UI_PANEL__ = {
    version: "1.2.3",
    buildTime: "12/27/2024 07:18 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const R = "av-messagebox", C = "av-panel", $ = "av-button";
/*!
  @versini/ui-spacing v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.0",
    buildTime: "12/27/2024 07:18 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Q = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, B = "icon", Z = "button", ee = "link", te = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a,
  align: o
}) => {
  const n = "text-sm font-medium max-h-8 py-0", c = "text-base font-medium max-h-9 py-1", l = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case Z:
      return d("px-4", {
        [n]: r === "small",
        [c]: r === "medium",
        [l]: r === "large"
      });
    case ee:
      return d("px-4 text-center", {
        [n]: r === "small",
        [c]: r === "medium",
        [l]: r === "large"
      });
    case B:
      return d("inline-flex items-center", {
        "justify-center": o === "center",
        "justify-start": o === "left",
        "justify-end": o === "right",
        "h-6 w-6 p-0": r === "small" && !(t || a),
        "h-6 px-4 text-sm font-medium": r === "small" && (t || a),
        "h-8 w-8 p-1": r === "medium" && !(t || a),
        "h-8 px-4 text-base font-medium": r === "medium" && (t || a),
        "h-12 w-12 p-2": r === "large" && !(t || a),
        "h-12 px-4 text-lg font-medium": r === "large" && (t || a)
      });
  }
}, re = ({
  mode: e,
  noBackground: r,
  noTruncate: t,
  variant: a
}) => {
  if (r)
    return "not-prose rounded-full";
  if (a === "primary")
    return d("not-prose rounded-full", {
      truncate: !t,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return d("not-prose rounded-full", {
      truncate: !t,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return d("not-prose rounded-full", {
      truncate: !t,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
}, ae = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return d("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (t === "secondary")
    return d("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (t === "danger")
    return d("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
}, oe = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return d("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (t === "secondary")
    return d("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (t === "danger")
    return d("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
}, ie = ({
  mode: e,
  noBorder: r,
  variant: t
}) => {
  if (r)
    return "border border-transparent";
  if (t === "primary")
    return d("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (t === "secondary")
    return d("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (t === "danger")
    return d("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
}, ne = ({ focusMode: e }) => d("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), V = ({
  type: e,
  className: r,
  raw: t,
  mode: a,
  focusMode: o,
  disabled: n,
  fullWidth: c,
  size: l,
  noBorder: h,
  labelRight: s,
  labelLeft: b,
  spacing: f,
  noBackground: m,
  variant: g,
  noTruncate: p,
  align: v
}) => (g || (g = "primary"), t ? d($, r) : d(
  $,
  r,
  Q(f),
  re({ mode: a, variant: g, noBackground: m, noTruncate: p }),
  te({ type: e, size: l, labelRight: s, labelLeft: b, align: v }),
  ie({ mode: a, variant: g, noBorder: h }),
  ne({ focusMode: o }),
  ae({ mode: a, variant: g, disabled: n }),
  oe({ mode: a, variant: g, disabled: n }),
  {
    "w-full": c,
    "disabled:cursor-not-allowed disabled:opacity-50": n
  }
)), le = (e, r, t) => {
  var a;
  !r && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof t == "function" && t(e);
}, M = T.forwardRef((e, r) => {
  const { onClick: t, noInternalClick: a = !1, ...o } = e;
  return /* @__PURE__ */ i(
    "button",
    {
      ref: r,
      onClick: (n) => {
        le(n, a, t);
      },
      ...o
    }
  );
});
M.displayName = "BaseButton";
const O = T.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: o = !1,
    className: n,
    type: c = "button",
    raw: l = !1,
    noBorder: h = !1,
    "aria-label": s,
    label: b,
    size: f = "medium",
    labelRight: m,
    labelLeft: g,
    spacing: p,
    noBackground: v = !1,
    align: y = "center",
    ...I
  }, N) => {
    const E = V({
      type: B,
      mode: t,
      focusMode: a,
      fullWidth: o,
      disabled: r,
      raw: l,
      className: n,
      noBorder: h,
      size: f,
      labelRight: m,
      labelLeft: g,
      spacing: p,
      noBackground: v,
      align: y
    }), S = d({
      "text-copy-accent-dark": t === "light" && !l,
      "text-copy-light": t === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !l
    });
    return /* @__PURE__ */ _(
      M,
      {
        ref: N,
        className: E,
        disabled: r,
        type: c,
        "aria-label": s || b,
        ...I,
        children: [
          g && /* @__PURE__ */ i("span", { className: "pr-2", children: g }),
          /* @__PURE__ */ i("div", { className: S, children: e }),
          m && /* @__PURE__ */ i("span", { className: "pl-2", children: m })
        ]
      }
    );
  }
);
O.displayName = "ButtonIcon";
/*!
  @versini/ui-button v1.6.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "1.6.0",
    buildTime: "12/27/2024 07:18 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const de = T.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: o = !1,
    className: n,
    type: c = "button",
    raw: l = !1,
    noBorder: h = !1,
    "aria-label": s,
    label: b,
    size: f = "medium",
    labelRight: m,
    labelLeft: g,
    spacing: p,
    noBackground: v = !1,
    align: y = "center",
    active: I = !1,
    ...N
  }, E) => {
    const S = V({
      type: B,
      mode: t,
      focusMode: a,
      fullWidth: o,
      disabled: r,
      raw: l,
      className: n,
      noBorder: h,
      size: f,
      labelRight: m,
      labelLeft: g,
      spacing: p,
      noBackground: v,
      align: y
    }), A = d({
      "text-copy-accent-dark": t === "light" && !l,
      "text-copy-light": t === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !l
    }), z = I ? d(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": t === "dark",
        "after:border-table-light": t === "light",
        "after:border-table-dark dark:after:border-table-light": t === "system",
        "after:border-table-light dark:after:border-table-dark": t === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ i("div", { className: z, children: /* @__PURE__ */ _(
      M,
      {
        ref: E,
        className: S,
        disabled: r,
        type: c,
        "aria-label": s || b,
        ...N,
        children: [
          g && /* @__PURE__ */ i("span", { className: "pr-2", children: g }),
          /* @__PURE__ */ i("div", { className: A, children: e }),
          m && /* @__PURE__ */ i("span", { className: "pl-2", children: m })
        ]
      }
    ) });
  }
);
de.displayName = "ButtonSort";
/*!
  @versini/ui-spacing v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.0",
    buildTime: "12/27/2024 07:18 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ce = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, se = ({
  children: e,
  fill: r,
  viewBox: t,
  className: a,
  defaultViewBox: o,
  defaultClassName: n,
  spacing: c,
  title: l,
  semantic: h = !1,
  ...s
}) => {
  const b = ce(c), f = d(
    b,
    a || n
  );
  return /* @__PURE__ */ _(L, { children: [
    /* @__PURE__ */ i(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: f,
        viewBox: t || o,
        fill: r || "currentColor",
        role: "img",
        "aria-hidden": !h,
        focusable: !1,
        ...s,
        children: e
      }
    ),
    l && h && /* @__PURE__ */ i("span", { className: "sr-only", children: l })
  ] });
};
/*!
  @versini/ui-svgicon v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "1.1.0",
    buildTime: "12/27/2024 07:18 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ge = ({
  className: e,
  viewBox: r,
  spacing: t,
  title: a,
  monotone: o,
  ...n
}) => /* @__PURE__ */ i(
  se,
  {
    defaultViewBox: "0 0 384 512",
    defaultClassName: "size-5",
    viewBox: r,
    className: e,
    spacing: t,
    title: a || "Close",
    ...n,
    children: /* @__PURE__ */ i("path", { d: "M342.6 150.6c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L192 210.7 86.6 105.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3L146.7 256 41.4 361.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L192 301.3l105.4 105.3c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L237.3 256l105.3-105.4z" })
  }
);
/*!
  @versini/ui-icons v1.19.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "1.19.0",
    buildTime: "12/27/2024 07:18 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const U = u.createContext(null);
function he({
  initialOpen: e = !1,
  open: r,
  onOpenChange: t
} = {}) {
  const [a, o] = u.useState(e), [n, c] = u.useState(), [l, h] = u.useState(), s = r ?? a, b = t ?? o, f = G({
    open: s,
    onOpenChange: b
  }), m = f.context, g = D(m, {
    enabled: r == null
  }), p = W(m, {
    outsidePress: !1,
    outsidePressEvent: "mousedown"
  }), v = X(m), y = Y([g, p, v]);
  return u.useMemo(
    () => ({
      open: s,
      setOpen: b,
      ...y,
      ...f,
      labelId: n,
      descriptionId: l,
      setLabelId: c,
      setDescriptionId: h
    }),
    [s, b, y, f, n, l]
  );
}
const w = () => {
  const e = u.useContext(U);
  if (e == null)
    throw new Error("Modal components must be wrapped in <Modal />");
  return e;
};
function ue({
  children: e,
  ...r
}) {
  const t = he(r);
  return /* @__PURE__ */ i(U.Provider, { value: t, children: e });
}
const me = u.forwardRef(function(e, r) {
  const { context: t, ...a } = w(), o = q([a.refs.setFloating, r]);
  if (!t.open)
    return null;
  const { overlayBackground: n, ...c } = e, l = d("grid place-items-center", {
    [`${n}`]: n,
    "bg-black sm:bg-black/[.8]": !n
  });
  return /* @__PURE__ */ i(H, { children: /* @__PURE__ */ i(J, { className: l, lockScroll: !0, children: /* @__PURE__ */ i(K, { context: t, children: /* @__PURE__ */ i(
    "div",
    {
      ref: o,
      "aria-labelledby": a.labelId,
      "aria-describedby": a.descriptionId,
      ...a.getFloatingProps(c),
      children: c.children
    }
  ) }) }) });
}), be = u.forwardRef(function({ children: e, ...r }, t) {
  const { setLabelId: a } = w(), o = P();
  return u.useLayoutEffect(() => (a(o), () => a(void 0)), [o, a]), /* @__PURE__ */ i("h1", { ...r, ref: t, id: o, children: e });
}), fe = u.forwardRef(function({ children: e, ...r }, t) {
  const { setDescriptionId: a } = w(), o = P();
  return u.useLayoutEffect(() => (a(o), () => a(void 0)), [o, a]), /* @__PURE__ */ i("div", { ...r, ref: t, id: o, children: e });
}), pe = u.forwardRef(function(e, r) {
  const { setOpen: t } = w(), { trigger: a, className: o, ...n } = e, c = u.useCallback(() => t(!1), [t]);
  return /* @__PURE__ */ i("div", { className: o, children: u.cloneElement(a, {
    ref: r,
    onClick: c,
    ...n
  }) });
});
/*!
  @versini/ui-modal v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_MODAL__ || (window.__VERSINI_UI_MODAL__ = {
    version: "1.1.0",
    buildTime: "12/27/2024 07:18 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const k = "panel", x = "messagebox", ve = ({
  className: e,
  kind: r,
  borderMode: t
}) => ({
  main: d("prose prose-lighter flex flex-col bg-surface-medium", {
    [`${C} max-h-full sm:max-h-[95%] min-h-full sm:min-h-[10rem] sm:rounded-lg sm:border-2`]: r === k,
    [`${C} w-full sm:w-[95%] md:max-w-2xl`]: r === k && !e,
    [`${R} rounded-lg border-2`]: r === x,
    [`${R} w-[95%] sm:w-[50%] md:max-w-2xl`]: r === x && !e,
    [`${e}`]: !!e,
    "sm:border-border-dark": t === "dark" && r === k,
    "sm:border-border-accent": t === "light" && r === k,
    "border-border-dark": t === "dark" && r === x,
    "border-border-accent": t === "light" && r === x
  }),
  content: "flex flex-col py-2 sm:py-4 sm:px-4 px-2 overflow-y-auto",
  footer: "flex flex-grow flex-col sm:p-4 p-2",
  header: "sm:p-4 mb-0 p-2",
  close: "sm:p-4 p-2"
}), we = ({
  open: e,
  onOpenChange: r,
  title: t,
  children: a,
  footer: o,
  borderMode: n = "light",
  kind: c = k,
  className: l
}) => {
  const h = j(""), s = ve({ className: l, kind: c, borderMode: n });
  return F(() => (e && (h.current = document.title, document.title = `${t} | ${h.current}`), () => {
    e && (document.title = h.current);
  }), [t, e]), /* @__PURE__ */ i(L, { children: e && /* @__PURE__ */ i(ue, { open: e, onOpenChange: r, children: /* @__PURE__ */ _(me, { className: s.main, children: [
    /* @__PURE__ */ _("div", { className: "flex flex-row-reverse items-center justify-between", children: [
      /* @__PURE__ */ i(
        pe,
        {
          className: s.close,
          trigger: /* @__PURE__ */ i(
            O,
            {
              mode: "dark",
              focusMode: "light",
              noBorder: !0,
              label: "Close",
              children: /* @__PURE__ */ i(ge, {})
            }
          )
        }
      ),
      /* @__PURE__ */ i(be, { className: s.header, children: t })
    ] }),
    /* @__PURE__ */ i(fe, { className: s.content, children: a }),
    o && /* @__PURE__ */ i("div", { className: s.footer, children: o })
  ] }) }) });
};
export {
  R as MESSAGEBOX_CLASSNAME,
  C as PANEL_CLASSNAME,
  we as Panel
};
